package subscribeplanhttp

import (
	"net/http"

	authmiddleware "legalgo-BE-go/internal/api/http/middleware/auth"
	subscribeplandomain "legalgo-BE-go/internal/domain/subscribe_plan"
	subscribeplansvc "legalgo-BE-go/internal/services/subscribe_plan"
	"legalgo-BE-go/internal/utilities/response"
	"legalgo-BE-go/internal/utilities/utils"

	"github.com/go-chi/chi/v5"
	"github.com/go-playground/validator/v10"
)

func CreateSubscribePlan(
	router chi.Router,
	validate *validator.Validate,
	subsSvc subscribeplansvc.SubscribePlan,
) {
	router.
		With(authmiddleware.Authorize()).
		Post("/subscribe-plan/create", func(w http.ResponseWriter, r *http.Request) {
			ctx := r.Context()

			var spec subscribeplandomain.SubscribePlanReq

			if err := utils.UnmarshalBody(r, &spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					"failed to unmarshal request",
				)
				return
			}

			if err := validate.Struct(spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.(validator.ValidationErrors).Error(),
				)
				return
			}

			if err := subsSvc.CreatePlan(spec); err != nil {
				response.ResponseWithErrorCode(
					ctx,
					w,
					err,
					response.ErrCreateEntity.Code,
					response.ErrCreateEntity.HttpCode,
					err.Error(),
				)
				return
			}

			response.RespondJsonSuccess(ctx, w, struct {
				Message string
			}{
				Message: "subscription plan created successfully.",
			})
		})
}
